<script setup lang="ts">
import router from '@/router'
import { type Ref, ref } from 'vue'
import { useAuthStore } from '@/stores/auth'
import { type User } from '@/types/User'

const dialog = ref(false)
const username = ref('')
const pass = ref('')
const authStore = useAuthStore()
const errorDialog = ref(false)

function navigateToMainMenu() {
  authStore.searchUser(username.value, pass.value)
  if (authStore.status === true) {
    // console.log(authStore.status)
    // console.log(username)
    // console.log(pass)
    dialog.value = false
    authStore.checkRole()
    authStore.changeAppBar()
    router.push({ name: 'mainmenu' })
  } else {
    // console.log(username)
    // console.log(pass)
    // console.log(authStore.status)
    errorDialog.value = true
  }
}

function byPassLogin() {
  dialog.value = false
  authStore.checkRole()
  authStore.changeAppBar()
  router.push({ name: 'mainmenu' })
}
</script>

<template>
  <v-row justify="center">
    <v-dialog v-model="dialog" persistent width="450">
      <template v-slot:activator="{ props }">
        <v-btn color="primary" v-bind="props" height="40px" width="150px"> Login </v-btn>
      </template>
      <v-card>
        <v-card-title>
          <span class="text-h5">Login</span>
        </v-card-title>
        <v-card-text>
          <v-container>
            <v-row>
              <v-col cols="12" md="13" class="mx-auto">
                <v-text-field
                  label="Username"
                  required
                  variant="outlined"
                  prepend-inner-icon="mdi-account"
                  v-model="username"
                ></v-text-field>
              </v-col>
              <v-col cols="12" md="13" class="mx-auto">
                <v-text-field
                  label="Password"
                  type="password"
                  required
                  variant="outlined"
                  prepend-inner-icon="mdi-lock-outline"
                  v-model="pass"
                ></v-text-field>
              </v-col>
            </v-row>
          </v-container>
          <small class="text-caption text-decoration-none text-blue"
            >Please enter your password.</small
          >
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue-darken-1" variant="text" @click="dialog = false"> Close </v-btn>
          <v-btn color="blue-darken-1" variant="text" @click="navigateToMainMenu()"> Login </v-btn>

          <v-dialog v-model="errorDialog" width="500px">
            <v-card>
              <br />
              <v-img
                style="margin-left: 230px"
                :width="40"
                src="\src\assets\Login\icon.png"
              ></v-img>
              <v-spacer></v-spacer>
              <v-card-title align="center" class="text-h5">Login Failed</v-card-title>
              <v-card-title align="center" class="text-h10">
                This action cannot be undone.<br />
                You need to put correct password.
              </v-card-title>
              <v-spacer></v-spacer>
              <div align="center">
                <div
                  style="
                    margin: 0 auto;
                    max-width: 400px;
                    border: 1px solid #dfe1e6;
                    border-radius: 5px;
                    margin-top: 10px;
                  "
                >
                  <v-btn block color="primary" variant="text" @click="errorDialog = false">
                    Cancel
                  </v-btn>
                </div>
              </div>
              <v-spacer></v-spacer>
              <br />
            </v-card>
          </v-dialog>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-row>
</template>

<style scoped></style>
